package fmon.stat

object Statistic extends Enumeration {
  val Hp = Value("Hp")
  val PAtk = Value("P. Atk")
  val PDef = Value("P. Def")
  val MAtk = Value("M. Atk")
  val MDef = Value("M. Def")
  val Speed = Value("Speed")
  val Accuracy = Value("Accuracy")
  val Evasion = Value("Evasion")
  
  def apply(s : String) = s match {
    case "hp" => Hp
    case "patk" => PAtk
    case "pdef" => PDef
    case "matk" => MAtk
    case "mdef" => MDef
    case "spd" => Speed
    case "acc" => Accuracy
    case "evd" => Evasion
  }
  
  def buildMap(f : Stat => Int)  : Map[Stat, Int] = {
    Map(Hp -> f(Hp), PAtk -> f(PAtk), PDef -> f(PDef), MAtk -> f(MAtk), MDef -> f(MDef), Speed -> f(Speed))
  }
  
  def emptyEvs = buildMap(_ => 0)
}