package fmon.stat

import fmon.util.TypeReference

object XpCurve extends Enumeration {
  case class Val protected(val curve: Int => Int) extends super.Val {
    def apply(xp : Int) = curve(xp)
  }
  
  val Fast = Val(xp => Math.cbrt(1.2 * xp).toInt)
  val MediumFast = Val(xp => Math.cbrt(xp).toInt)
  val MediumSlow = Val(xp => Math.cbrt(0.85 * xp).toInt)
  val Slow = Val(xp => Math.cbrt(0.75 * xp).toInt)
}
class XpCurveType extends TypeReference[XpCurve.type]